/*
  ESP32_MQ-9
  board DOIT ESP32 DEVKIT V1
*/

#include <WiFi.h>
#include <PubSubClient.h>

// Update these with values suitable for your network.
const char* ssid = "MYNETWORK";
const char* password = "mypasswd";
const char* mqtt_server = "192.168.xxx.xxx";

WiFiClient espClient;
PubSubClient client(espClient);
const char* topic1 = "MQ-9-A";
const char* topic2 = "MQ-9-V";
const char* topic3 = "MQ-9-S";

int zaktiv = 0;
long lastMsg = 0;
char msg[50];
char vzeile[ ] = " ";
String s2 = " ";
String s3 = " ";
String s4 = " ";

double rawData5;
double rawData6;
double rawData7;

float sensor_volt; 
float RS_air; //  Get the value of RS via in a clear air
float R0;  // Get the value of R0 via in LPG
float sensorValue;
uint8_t ADC7 = 35; 
uint16_t adc;

volatile boolean process_it;
String pzeile = "                                                                                                                  ";

static String slave_msg = "";
static String slave_msg1 = "";
static String slave_msg2 = "";
int anz_callback = 0;
int anz_slave_bytes = 0;

//----------------------------------------
//  callback_after_slave_tx_finish routine
//----------------------------------------
int callback_after_slave_tx_finish() {
    anz_callback++;
    if (anz_callback > 136)  
     {
       process_it = true;
       anz_callback = 0; 
     }  
    return 0;
}

void setup() 
{
  Serial.begin(115200);
  setup_wifi();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
  //Versionspflege
  Serial.println("ESP32S_MQ-9_V6");
}

void setup_wifi() {
  delay(10);
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  delay(500);
}

void callback(char* topic, byte* payload, unsigned int length) {
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  pzeile = "                                                                                                                  ";
  for (int i = 0; i < length; i++) {
    pzeile[i] = payload[i];
    vzeile[i] = pzeile[i];
  }
  Serial.println(pzeile);  
}  // ende  void callback

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    //################################################################
    // eindeutiger Client-Name für jedes NodeMCU-Modul verwenden.
    // steht im mosquitto-broker log  /var/log/mosquitto/mosquitto.log
    //################################################################
    if (client.connect("MQ9ESP32S")) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      client.publish("MQ9ESP32Sinit", "hello world");
      // ... and resubscribe
      client.subscribe("inTopic");
      //client.subscribe("#");    // alle topics lesen mit #
     } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(3000);
    }
  }
}

//********************************************************************************************
//* Loop Loop  Loop Loop  Loop Loop  Loop Loop  Loop Loop  Loop Loop  Loop Loop 
//******************************************************************************************* 
void loop() {
  if (!client.connected()) {
    reconnect();
  }
  client.loop();
  unsigned long currentMillis = millis();

/*--- Get a average data by testing 100 times ---*/ 
  sensorValue = 0;  
  for(int x = 0 ; x < 100 ; x++)
  {
    sensorValue = sensorValue + analogRead(ADC7);
  }
  sensorValue = sensorValue/100.0;
/*-----------------------------------------------*/
  sensorValue = 0;
  sensorValue = sensorValue + analogRead(ADC7);

  sensor_volt = sensorValue/4096*5.0;
  RS_air = (5.0-sensor_volt)/sensor_volt; 
  R0 = RS_air/9.9; // The ratio of RS/R0 is 9.9 in LPG gas

  Serial.print("sensor_Value = ");
  Serial.println(sensorValue);
  
  Serial.print("sensor_volt = ");
  Serial.print(sensor_volt);
  Serial.println("V");
  
  Serial.print("R0 = ");
  Serial.println(R0);
  Serial.println("  ");
 
  rawData5 = sensorValue;
  rawData6 = sensor_volt;
  rawData7 = R0;
  
  char kzeile[ ] = "                                                                                               ";
 
  s2 = " ";
  s3 = "sensor_Value ";
  s2 = s3  + rawData5;
  s2.toCharArray(kzeile, 50);
 
  //------------------------------------------------
  // message3 mit datenzeile an token MQ-9 ausgeben (AD-Wandler)
  snprintf (msg, 50, kzeile); //--> aktuelle ausgabe
  Serial.println("MQTT Publish message: ");  
  Serial.println(msg);
  client.publish(topic1, msg);
  
  s2 = " ";
  s3 = "sensor_volt V ";
  s2 = s3  + rawData6;
  s2.toCharArray(kzeile, 50);
 
  //------------------------------------------------
  // message4 mit datenzeile an token MQ-9 ausgeben (Spannung)
  snprintf (msg, 50, kzeile); //--> aktuelle ausgabe
  Serial.println("MQTT Publish message: ");  
  Serial.println(msg);
  client.publish(topic2, msg);

  s2 = " ";
  s3 = "R0 ";
  s2 = s3  + rawData7;
  s2.toCharArray(kzeile, 50);
 
  delay(4000);  

}
